Subject: Re: [i2c] [PATCH] update module-init-tools to support the i2c subsystem

From: Jean Delvare <[email-masked]>
Date: Mon, 14 Jan 2008 18:50:56 +0100

On Mon, 14 Jan 2008 18:08:16 +0100 (CET), Geert Uytterhoeven wrote:
> On Mon, 14 Jan 2008, Jean Delvare wrote:
> > I thought that the module aliases were generated by
> > scripts/mod/modpost? As a matter of fact, I did not apply Jon's patch
> 
> Sorry, you're right. Too early in the morning :-)
> 
> > to module-init-tools, and "modinfo" shows me module aliases properly
> > for i2c drivers that call MODULE_DEVICE_TABLE():
> 
> I've just looked it up again (I had to do a similar thing for Zorro bus
> support).  Module-init-tools (depmod) also creates the modules.*map files,
> which are used to map from device IDs to module names. I think these are used
> by udev to load the appropriate module when a device with a specific device ID
> pops up in sysfs.

Ah, right. I see it now, there's modules.isapnpmap,
modules.ieee1394map, modules.pcimap etc. but no modules.i2cmap.
However, there is modules.alias which contains the i2c aliases for all
device types (including one ieee1394 and many pci aliases) which seems
somewhat redundant with the modules.*map files.

> > $ /sbin/modinfo lm90
> > filename:       /lib/modules/2.6.24-rc7-git4/kernel/drivers/hwmon/lm90.ko
> > author:         Jean Delvare <[email-masked]>
> > description:    LM90/ADM1032 driver
> > license:        GPL
> > vermagic:       2.6.24-rc7-git4 mod_unload
> > depends:        hwmon
> > alias:          i2c:Nlm90*
> > alias:          i2c:Nadm1032*
> > alias:          i2c:Nlm99*
> > alias:          i2c:Nlm86*
> > alias:          i2c:Nmax6657*
> > alias:          i2c:Nadt7461*
> > alias:          i2c:Nmax6680*
> > $
> > 
> > "modprobe i2c:Nadm1032" loads the lm90 driver as expected.
> 
> Yes, it's also still not 100% clear to me when `i2c:Nadm1032' is used, and when
> modules.i2cmap would be used...

I am under the impression that modules.*map are the old way to get
automatic driver loading and aliases are the new way to do the same.
But maybe that's just me.

-- 
Jean Delvare